﻿//
// MinMaxCloseControl.xaml.cpp
// Implementation of the MinMaxCloseControl class
//

#include "pch.h"

#include "MinMaxCloseControl.h"

#include "MinMaxCloseControl.g.cpp"

namespace winrt::TerminalApp::implementation
{
    MinMaxCloseControl::MinMaxCloseControl()
    {
        InitializeComponent();
    }

    uint64_t MinMaxCloseControl::ParentWindowHandle() const
    {
        return reinterpret_cast<uint64_t>(_window);
    }

    void MinMaxCloseControl::ParentWindowHandle(uint64_t handle)
    {
        _window = reinterpret_cast<HWND>(handle);
    }

    void MinMaxCloseControl::_OnMaximize(byte flag)
    {
        if (_window)
        {
            POINT point1 = {};
            ::GetCursorPos(&point1);
            const LPARAM lParam = MAKELPARAM(point1.x, point1.y);
            WINDOWPLACEMENT placement = { sizeof(placement) };
            ::GetWindowPlacement(_window, &placement);
            if (placement.showCmd == SW_SHOWNORMAL)
            {
                winrt::Windows::UI::Xaml::VisualStateManager::GoToState(this->Maximize(), L"WindowStateMaximized", false);
                ::PostMessage(_window, WM_SYSCOMMAND, SC_MAXIMIZE | flag, lParam);
            }
            else if (placement.showCmd == SW_SHOWMAXIMIZED)
            {
                winrt::Windows::UI::Xaml::VisualStateManager::GoToState(this->Maximize(), L"WindowStateNormal", false);
                ::PostMessage(_window, WM_SYSCOMMAND, SC_RESTORE | flag, lParam);
            }
        }
    }

    void MinMaxCloseControl::Maximize_Click(winrt::Windows::Foundation::IInspectable const& sender, winrt::Windows::UI::Xaml::RoutedEventArgs const& e)
    {
        _OnMaximize(HTMAXBUTTON);
    }

    void MinMaxCloseControl::DragBar_DoubleTapped(winrt::Windows::Foundation::IInspectable const& sender, winrt::Windows::UI::Xaml::Input::DoubleTappedRoutedEventArgs const& e)
    {
        _OnMaximize(HTCAPTION);
    }

    void MinMaxCloseControl::Minimize_Click(winrt::Windows::Foundation::IInspectable const& sender, winrt::Windows::UI::Xaml::RoutedEventArgs const& e)
    {
        if (_window)
        {
            ::PostMessage(_window, WM_SYSCOMMAND, SC_MINIMIZE | HTMINBUTTON, 0);
        }
    }

    void MinMaxCloseControl::Close_Click(winrt::Windows::Foundation::IInspectable const& sender, winrt::Windows::UI::Xaml::RoutedEventArgs const& e)
    {
        ::PostQuitMessage(0);
    }

}
